
\echo Use "CREATE EXTENSION osm_fdw" to load this file. \quit

CREATE FUNCTION osm_fdw_handler()
RETURNS fdw_handler
AS 'MODULE_PATHNAME'
LANGUAGE C STRICT;

CREATE FUNCTION osm_fdw_validator(text[], oid)
RETURNS void
AS 'MODULE_PATHNAME'
LANGUAGE C STRICT;

CREATE FOREIGN DATA WRAPPER osm_fdw
  HANDLER osm_fdw_handler
  VALIDATOR osm_fdw_validator;

--CREATE OR REPLACE LANGUAGE plpgsql;
DROP FUNCTION IF EXISTS create_osm_table(text,text);
CREATE OR REPLACE FUNCTION create_osm_table(table_name text, server_name text, file_name text) RETURNS void AS $$
BEGIN
    EXECUTE 'CREATE FOREIGN TABLE ' || quote_ident(table_name) || ' (
        id bigint,
        type text,
        lat double precision,
        lon double precision,
        tags jsonb,
        refs bigint[],
        members jsonb,

        version int,
        modified timestamp,
        changeset bigint,
        user_id int,
        username text,
        visible boolean
    )
    SERVER ' || quote_ident(server_name) || '
    OPTIONS (filename ' || quote_literal(file_name) || ');';
END;
$$ LANGUAGE plpgsql;
